From dcfbfb4ac366ae22036fdc791cd02fa3dc4a48f1 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 22 2017 18:23:02 +0000
Subject: [PATCH 884/1001] Create links for user hubs in Feed messages


---

diff --git a/hubs/feed.py b/hubs/feed.py
index 786844b..5fb9546 100644
--- a/hubs/feed.py
+++ b/hubs/feed.py
@@ -3,8 +3,10 @@ from __future__ import unicode_literals
 import hashlib
 import logging
 import os
+import re
 
 import fedmsg.meta
+import flask
 import redis
 from fedmsg.encoding import loads, dumps
 
@@ -66,14 +68,41 @@ def format_msg(msg):
     # invariant through conglomerate() calls.
     msg["dom_id"] = hashlib.sha1(
         b":".join(
-            [mid.encode("utf-8") for mid in msg["msg_ids"]]
+            [mid.encode("utf-8") for mid in sorted(msg["msg_ids"])]
         )).hexdigest()
     # TODO: generate markup
-    msg["markup"] = msg["subtitle"]
-    msg["markup_subjective"] = msg["subjective"]
+    msg["markup"] = _make_hub_links(msg, "subtitle")
+    msg["markup_subjective"] = _make_hub_links(msg, "subjective")
     return msg
 
 
+_word_split_re = re.compile(r'(\s+)')
+_punctuation_re = re.compile(
+    '^(?P<lead>(?:%s)*)(?P<middle>.*?)(?P<trail>(?:%s)*)$' % (
+        '|'.join(map(re.escape, ('(', '<', '&lt;'))),
+        '|'.join(map(re.escape, ('.', ',', ')', '>', '\n', '&gt;', "'s")))
+    )
+)
+
+
+def _make_hub_links(msg, attr):
+    if not msg.get(attr):
+        return ""
+    existing_usernames = [r[0] for r in User.query.values(User.username)]
+    usernames = [u for u in msg["usernames"] if u in existing_usernames]
+    words = _word_split_re.split(msg[attr])
+    for i, word in enumerate(words):
+        match = _punctuation_re.match(word)
+        if match:
+            lead, middle, trail = match.groups()
+            if middle in usernames:
+                middle = '<a href="{}">{}</a>'.format(
+                    flask.url_for("hub", name=middle), middle)
+            if lead + middle + trail != word:
+                words[i] = lead + middle + trail
+    return ''.join(words)
+
+
 class Feed(object):
 
     max_items = 100
diff --git a/hubs/tests/test_feed.py b/hubs/tests/test_feed.py
index 29b21ba..042ff55 100644
--- a/hubs/tests/test_feed.py
+++ b/hubs/tests/test_feed.py
@@ -117,3 +117,29 @@ class FeedTest(APPTest):
             sorted(get_hubs_for_msg({"msg_id": "testmsg"})),
             ["infra", "ralph", "testhub"]
             )
+
+    def test_format_msg(self):
+        msg = {
+            "msg_ids": {
+                "testid1": {"msg_id": "testid1"},
+                "testid2": {"msg_id": "testid2"},
+                "testid3": {"msg_id": "testid3"},
+            },
+            "usernames": ["ralph", "decause"],
+            "subtitle": "ralph's ticket was commented by decause",
+            "subjective": "your ticket was commented by decause",
+        }
+        with app.test_request_context():
+            result = format_msg(msg)
+        self.assertEqual(
+            result["dom_id"],
+            "067306d0b091ec48d9e2dded1ca9b1f8b1b2ac93")
+        self.assertEqual(
+            result["markup"],
+            """<a href="/ralph/">ralph</a>'s ticket was commented by """
+            """<a href="/decause/">decause</a>"""
+            )
+        self.assertEqual(
+            result["markup_subjective"],
+            """your ticket was commented by <a href="/decause/">decause</a>"""
+            )

